/*
 * Program: SSL-WOPR Server
 * Source : wopr.h
 * Purpose: Implementation of WOPR's exception classes.
 *
 * Copyright (c) 2009, 2010 Oliver Mueller.
 * All rights reserved.
 * http://www.cogito-ergo-sum.org
 *
 * This software is provided 'as-is', without any express or implied warranty.
 * In no event will the author be held liable for any damages arising from
 * the use of this software.
 *
 */

#include <exception>

#include <string.h>

#include "woprexcept.h"

WOPR_exception::WOPR_exception(const char *error) :
    exception()
{
    strncpy(msg, error, ERRSIZE);
    msg[ERRSIZE - 1] = '\0';
}

const char *WOPR_exception::what() const throw ()
{
    return msg;
}

CTX_exception::CTX_exception(const char *error) :
    WOPR_exception(error)
{
}

SSL_exception::SSL_exception(const char *error) :
    WOPR_exception(error)
{
}

Overflow_exception::Overflow_exception() :
    exception()
{
}

const char *Overflow_exception::what() const throw ()
{
    return "Buffer overflow condition detected.";
}

SSL_init_mutex_exception::SSL_init_mutex_exception(const char *error) :
    WOPR_exception(error)
{
}
