/*
 * Program: SSL-WOPR Server
 * Source : wopr.h
 * Purpose: Declaration of WOPR's exception classes.
 *
 * Copyright (c) 2009, 2010 Oliver Mueller.
 * All rights reserved.
 * http://www.cogito-ergo-sum.org
 *
 * This software is provided 'as-is', without any express or implied warranty.
 * In no event will the author be held liable for any damages arising from
 * the use of this software.
 *
 */

#ifndef __WOPREXCEPT_H
#define __WOPREXCEPT_H

#include <exception>

#define ERRSIZE   1024

using namespace std;

class WOPR_exception : public exception
{
public:
    WOPR_exception(const char *error);
    const char *what() const throw ();
protected:
    char msg[ERRSIZE];
};

class CTX_exception : public WOPR_exception
{
public:
    CTX_exception(const char *error);
};

class SSL_exception : public WOPR_exception
{
public:
    SSL_exception(const char *error);
};

class Overflow_exception : public exception
{
public:
    Overflow_exception();
    const char *what() const throw ();
};

class SSL_init_mutex_exception : public WOPR_exception
{
public:
    SSL_init_mutex_exception(const char *error = "Initialization of at least one OpenSSL mutex failed.");
};

#endif
